/**
 * Validator for public key records.
 * Verifies that the passed in record value is the PublicKey
 * that matches the passed in key.
 * If validation fails the returned Promise will reject with the error.
 *
 * @param {Uint8Array} key - A valid key is of the form `'/pk/<keymultihash>'`
 * @param {Uint8Array} publicKey - The public key to validate against (protobuf encoded).
 */
declare function validatePublicKeyRecord(key: Uint8Array, publicKey: Uint8Array): Promise<void>;
export { validatePublicKeyRecord as func };
export declare const sign: boolean;
//# sourceMappingURL=public-key.d.ts.map